SystemOrganization addCategory: #'StashShell-Tests-Core'!

PPCompositeParserTest subclass: #StashArgsParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashArgsParserTests methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:50'!
parserClass

	^StashArgsParser! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 19:09'!
testDots

	self assert: '..' is: #('..').
	self assert: '.' is: #('.').
	! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:51'!
testEmpty

	self assert: '' is: #()! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testKeyword

	self assert: '-a' is: #('-a')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testKeywordAndArg

	self assert: '-a daleh' is: #( '-a' 'daleh')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testKeywords

	self assert: '-altr' is: #('-altr')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:51'!
testMixed

	self assert: '-f dale -altr kentland henrichs' is: #('-f' 'dale' '-altr' 'kentland' 'henrichs')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:51'!
testMixed2

	self assert: '-f dale kentland -altr henrichs' is: #('-f' 'dale' 'kentland' '-altr' 'henrichs')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:52'!
testMultipleKeywordAndArg

	self assert: '-a daleh -f fun' is: #('-a' 'daleh' '-f' 'fun')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:53'!
testMultipleNoKeyword
	
	self assert: 'dale henrichs' is: #( 'dale' 'henrichs')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:53'!
testNoKeyword

	self assert: 'dale' is: #('dale')! !

!StashArgsParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 19:13'!
testPaths

	self assert: '../' is: #('../').
	self assert: './' is: #('./').
	self assert: '/' is: #('/').
	self assert: 'a/b/c/d/e/f' is: #('a/b/c/d/e/f').
	self assert: 'a/b/../../e/f' is: #('a/b/../../e/f').
	self assert: 'a/b/c/d/e/f/' is: #('a/b/c/d/e/f/').
	self assert: '/a/b/c/d/e/f' is: #('/a/b/c/d/e/f').
	! !

PPCompositeParserTest subclass: #StashCommandParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashCommandParserTests methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 11:46'!
parserClass

	^StashCommandParser! !

!StashCommandParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 14:54'!
testCommand

	self assert: 'ls' is: 'ls'! !

TestCase subclass: #StashShellTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/12/2010 09:59'!
testHelp
	| output expected input |
	input := WriteStream on: String new.
	input
		nextPutAll: 'help';
		cr.
	expected := 'Smaltalk shell, version 1.0
These shell commands are defined internally.
Type ''help'' to see this list.
Type ''help name'' to find out more about the function ''name''.
Use ''info stash'' to find out more about she shell in general.

cd [-dfh] [dir]
help [-dh] [functionName]
ls [-adh] [file ...]
mkdir [-dh] dir...
mount [-dh] device mount_point
'.
	self assert: (output := StashShell executeScript: input contents) = expected contents! !

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/11/2010 14:53'!
testLs

	| output expected |
	expected := 'dev
'.
	self assert: (output := StashShell executeScript: 'ls') = expected contents! !

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/12/2010 08:38'!
testLsError

	| output expected |
	expected := 'ls: mnt: No such file or directory
'.
	self assert: (output := StashShell executeScript: 'ls mnt') = expected contents! !

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/11/2010 14:53'!
testMkdir
	| output expected input |
	input := WriteStream on: String new.
	input
		nextPutAll: 'mkdir etc';
		cr;
		nextPutAll: 'ls';
		cr.
	expected := '
dev
etc
'.
	self assert: (output := StashShell executeScript: input contents) = expected contents! !

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/11/2010 14:53'!
testMkdirWithArgs
	| output expected input |
	input := WriteStream on: String new.
	input
		nextPutAll: 'mkdir etc home bin';
		cr;
		nextPutAll: 'ls';
		cr.
	expected := '
bin
dev
etc
home
'.
	self assert: (output := StashShell executeScript: input contents) = expected contents! !

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/11/2010 14:54'!
testMkdirWithErrors
	| output expected input |
	input := WriteStream on: String new.
	input
		nextPutAll: 'mkdir etc home bin';
		cr;
		nextPutAll: 'mkdir 1 2 home bin 3 4';
		cr;
		nextPutAll: 'ls';
		cr.
	expected := '
mkdir: 1 2 home bin 3 4: cannot create directory: ''home'': File exists
mkdir: 1 2 home bin 3 4: cannot create directory: ''bin'': File exists
1
2
3
4
bin
dev
etc
home
'.
	self assert: (output := StashShell executeScript: input contents) = expected contents! !

!StashShellTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/11/2010 16:11'!
testMount
	| output expected input |
	input := WriteStream on: String new.
	input
		nextPutAll: 'mkdir mnt';
		cr;
		nextPutAll: 'mount /dev/configs /mnt/c';
		cr;
		nextPutAll: 'ls';
		cr;
		nextPutAll: 'ls mnt';
		cr;
		nextPutAll: 'cd mnt';
		cr;
		nextPutAll: 'ls';
		cr.
	expected := '

dev
mnt
c

c
'.
	self assert: (output := StashShell executeScript: input contents) = expected contents! !

TestCase subclass: #StashStreamParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Tests-Core'!

!StashStreamParserTests methodsFor: 'tests' stamp: 'DaleHenrichs 12/9/2010 15:12'!
test

	| commandLine stream commandParser argsParser result |
	commandLine := 'ls -f dale kentland -altr henrichs'.
	stream := commandLine asPetitStream.
	commandParser := StashCommandParser new.
	self assert: (result := commandParser parse: stream) = 'ls'.
	stream := (commandLine copyFrom: result size + 1 to: commandLine size) withBlanksTrimmed asPetitStream.
	argsParser := StashArgsParser new.
	self assert: (result := argsParser parse: stream) = #('-f' 'dale' 'kentland' '-altr' 'henrichs').! !
